#include <stdlib.h>
#include <stdio.h>
#include <stdarg.h>
#include <unistd.h>
#include <ctype.h>
#include <errno.h>
#include <getopt.h>
#include <fcntl.h>
#include <signal.h>
#include <math.h>
#include <string.h>
#include <sys/ioctl.h>
#include <sys/mount.h>
#include <linux/hdreg.h>
#include <python2.3/Python.h>

//#include <linux/fs.h>
//#include <sys/types.h>
//#include <errno.h>



#if defined(__GNUC__) || defined(HAS_LONG_LONG)
typedef long long ext2_loff_t;
#else
typedef long      ext2_loff_t;
#endif


extern ext2_loff_t ext2_llseek(unsigned int fd, ext2_loff_t offset,
			       unsigned int origin);
#define PRIMARY -2
#define UNUSABLE -1
#define LOGICAL -3
#define MAXIMUM_PARTS 60
#define PRI_LOG    -1
#define MAX_CYLINDERS 65535
#define MAX_HEADS 255
#define MAX_SECTORS 63
#define LABELSZ 11
#define SECTOR_SIZE 512
#define PRI_OR_LOG -1
#define NUM_PART_TYPES 256


#define ACTIVE_FLAG 0x80
#define PART_TABLE_FLAG 0xAA55

#define DOS_EXTEND 0x05
#define WIN98_EXTENED 0x0f
#define LINUX_EXTEND 0x85
#define LINUX_MINIX 0x81
#define LINUX_SWAP 0x82
#define LINUX 0x83
#define FREE_SPACE 0x00
#define ceil(d) ((double)(((d) != (int)(d)) ? (int)(d+1.0):(int)(d)))
#define IS_PRIMARY(p)  ((p) >=0 && (p) <4)
#define IS_LOGICAL(p)  ((p) > 3)
#define IS_EXTENDED(p)  ((p) == DOS_EXTEND || (p) == LINUX_EXTEND || (p) == WIN98_EXTENED)
#define IS_DOS_PART(p)  ((p) == 1 || (p) == 4 || (p) == 6)
#define round(p) ((double)((int)(p + 0.5)))
#define num_cyls(bytes) (round(bytes/SECTOR_SIZE/(sectors[hard_num]*heads[hard_num])))
#define set_hsc(h,s,c,sector) \
{ \
      s = sector % sectors[hard_num] + 1;	\
      sector /= sectors[hard_num];	\
      h = sector % heads[hard_num];	\
      sector /= heads[hard_num];		\
      c = sector & 0xFF;	\
      s |= (sector >> 2) & 0xC0;\
}

struct partition {
    unsigned char boot_ind;     /* 0x80 - active */
    unsigned char head;     /* starting head */
    unsigned char sector;       /* starting sector */
    unsigned char cyl;      /* starting cylinder */
    unsigned char sys_ind;      /* What partition type */
    unsigned char end_head;     /* end head */
    unsigned char end_sector;   /* end sector */
    unsigned char end_cyl;      /* end cylinder */
    unsigned int start_sect;    /* starting sector counting from 0 */
    unsigned int nr_sects;      /* nr of sectors in partition */
} __attribute__((packed));


typedef union{
	struct{
		 unsigned char align[2];
		 unsigned char b[512];
	}c;
	struct{
		 unsigned char align[2];
		 unsigned char buffer[0x1BE];
		struct partition part[4];
		 unsigned short flag;
	}p;
}partition_table;

typedef struct{
	int first_sector;
	int last_sector;
	int offset;
	int flags;
	int id;
	int num;
	char dos_label[12];
}partition_info;

int opentype;
int fd[10];
int read_num[10];
int write_num[10];
int hard_num = 0;
int heads[10] ;
int sectors[10] ;
int cylinders[10];
int num_parts[10];
int zero_table = 0;
int logical = 0;
int logical_sectors[MAXIMUM_PARTS];
int read_error = 0;
partition_table bufferss[10];
partition_info  p_info[10][MAXIMUM_PARTS];
partition_info  ext_info[10];


void read_sector(char *buffer, int sect_num)
{
   if(ext2_llseek(fd[hard_num], ((ext2_loff_t) sect_num)*SECTOR_SIZE, SEEK_SET) < 0){
 	printf("BAD_SEEK");
   	read_error = 1;}
   if(read_num[hard_num] = read(fd[hard_num], buffer, SECTOR_SIZE) !=SECTOR_SIZE){
	printf("BAD_READ\n");
   	read_error = 1;}
}

void write_sector(char *buffer, int sect_num)
{
   if(ext2_llseek(fd[hard_num], ((ext2_loff_t) sect_num)*SECTOR_SIZE, SEEK_SET) < 0)
 	printf("BAD_SEEK");
   if(read_num[hard_num] = write(fd[hard_num], buffer, SECTOR_SIZE) !=SECTOR_SIZE)
	printf("BAD_WRITE");
}

void get_dos_label(int i)
{
    char label[LABELSZ+1];
    ext2_loff_t offset;
    int j;

    offset = ((ext2_loff_t) p_info[hard_num][i].first_sector + p_info[hard_num][i].offset)
	 * SECTOR_SIZE + 43;
    if (ext2_llseek(fd[hard_num], offset, SEEK_SET) == offset
	&& read(fd[hard_num], &label, LABELSZ) == LABELSZ) {
	 for(j=0; j<LABELSZ; j++)
	      if(!isascii(label[j]))
		   label[j] = 0;
	 label[LABELSZ] = 0;
	 strcpy(p_info[hard_num][i].dos_label, label);
    }
}


int find_primary(int hardnum)
{
    int num = 0, cur = 0;
    hard_num = hardnum;
    while (cur < num_parts[hard_num] && IS_PRIMARY(num))
	if ((p_info[hard_num][cur].id > 0 && p_info[hard_num][cur].num == num) ||
	    (IS_EXTENDED(ext_info[hard_num].id) && ext_info[hard_num].num == num)) {
	    num++;
	    cur = 0;
	} else
	    cur++;

    if (!IS_PRIMARY(num))
	return -1;
    else
	return num;
}

int find_logical(int hardnum,int i)
{
    int num = -1;
    int j;
    hard_num = hardnum;
    for (j = i; j < num_parts[hard_num] && num == -1; j++)
	if (p_info[hard_num][j].id > 0 && IS_LOGICAL(p_info[hard_num][j].num))
	    num = p_info[hard_num][j].num;

    if (num == -1) {
	num = 4;
	for (j = 0; j < num_parts[hard_num]; j++)
	    if (p_info[hard_num][j].id > 0 && p_info[hard_num][j].num == num)
		num++;
    }

    return num;
}

void inc_logical(int i)
{
    int j;

    for (j = i; j < num_parts[hard_num]; j++)
	if (p_info[hard_num][j].id > 0 && IS_LOGICAL(p_info[hard_num][j].num))
	    p_info[hard_num][j].num++;
}





void check_part_info(void)
{
    int i, pri = 0, log = 0;

    for (i = 0; i < num_parts[hard_num]; i++)
	if (p_info[hard_num][i].id > 0 && IS_PRIMARY(p_info[hard_num][i].num))
	    pri++;
	else if (p_info[hard_num][i].id > 0 && IS_LOGICAL(p_info[hard_num][i].num))
	    log++;
    if (IS_EXTENDED(ext_info[hard_num].id))
	if (log > 0)
	    pri++;
	else {
	    ext_info[hard_num].first_sector = 0;
	    ext_info[hard_num].last_sector = 0;
	    ext_info[hard_num].offset = 0;
	    ext_info[hard_num].flags = 0;
	    ext_info[hard_num].id = FREE_SPACE;
	    ext_info[hard_num].num = PRIMARY;
	}

    if (pri >= 4) {
	for (i = 0; i < num_parts[hard_num]; i++)
	    if (p_info[hard_num][i].id == FREE_SPACE || p_info[hard_num][i].id == UNUSABLE)
		if (IS_EXTENDED(ext_info[hard_num].id))
		    if (p_info[hard_num][i].first_sector >= ext_info[hard_num].first_sector &&
			p_info[hard_num][i].last_sector <= ext_info[hard_num].last_sector) {
			p_info[hard_num][i].id = FREE_SPACE;
			p_info[hard_num][i].num = LOGICAL;
		    } else if (i > 0 &&
			       p_info[hard_num][i-1].first_sector >=
			       ext_info[hard_num].first_sector &&
			       p_info[hard_num][i-1].last_sector <=
			       ext_info[hard_num].last_sector) {
			p_info[hard_num][i].id = FREE_SPACE;
			p_info[hard_num][i].num = LOGICAL;
		    } else if (i < num_parts[hard_num]-1 &&
			       p_info[hard_num][i+1].first_sector >=
			       ext_info[hard_num].first_sector &&
			       p_info[hard_num][i+1].last_sector <=
			       ext_info[hard_num].last_sector) {
			p_info[hard_num][i].id = FREE_SPACE;
			p_info[hard_num][i].num = LOGICAL;
		    } else
			p_info[hard_num][i].id = UNUSABLE;
		else 
		    p_info[hard_num][i].id = UNUSABLE;
	    else 
		while (0); 
    } else { 
	for (i = 0; i < num_parts[hard_num]; i++) {
	    if (p_info[hard_num][i].id == UNUSABLE)
		p_info[hard_num][i].id = FREE_SPACE;
	    if (p_info[hard_num][i].id == FREE_SPACE)
		if (IS_EXTENDED(ext_info[hard_num].id))
		    if (p_info[hard_num][i].first_sector >= ext_info[hard_num].first_sector &&
			p_info[hard_num][i].last_sector <= ext_info[hard_num].last_sector)
			p_info[hard_num][i].num = LOGICAL;
		    else if (i > 0 &&
			     p_info[hard_num][i-1].first_sector >=
			     ext_info[hard_num].first_sector &&
			     p_info[hard_num][i-1].last_sector <=
			     ext_info[hard_num].last_sector)
			p_info[hard_num][i].num = PRI_OR_LOG;
		    else if (i < num_parts[hard_num]-1 &&
			     p_info[hard_num][i+1].first_sector >=
			     ext_info[hard_num].first_sector &&
			     p_info[hard_num][i+1].last_sector <=
			     ext_info[hard_num].last_sector)
			p_info[hard_num][i].num = PRI_OR_LOG;
		    else
			p_info[hard_num][i].num = PRIMARY;
		else 
		    p_info[hard_num][i].num = PRI_OR_LOG;
	    else 
		while (0);
	}
    }
}

void insert_empty_part(int i, int first, int last)
{
    int p;

    for (p = num_parts[hard_num]; p > i; p--)
	 p_info[hard_num][p] = p_info[hard_num][p-1];

    p_info[hard_num][i].first_sector = first;
    p_info[hard_num][i].last_sector = last;
    p_info[hard_num][i].offset = 0;
    p_info[hard_num][i].flags = 0;
    p_info[hard_num][i].id = FREE_SPACE;
    p_info[hard_num][i].num = PRI_OR_LOG;
    p_info[hard_num][i].dos_label[0] = 0;

    num_parts[hard_num]++;
}

void clear_p_info(int hardnum)
{
    hard_num = hardnum;
    num_parts[hard_num] = 1;
    p_info[hard_num][0].first_sector = 0;
    p_info[hard_num][0].last_sector = sectors[hard_num]*heads[hard_num]*cylinders[hard_num] - 1;
    p_info[hard_num][0].offset = 0;
    p_info[hard_num][0].flags = 0;
    p_info[hard_num][0].id = FREE_SPACE;
    p_info[hard_num][0].num = PRI_LOG;

    ext_info[hard_num].first_sector = 0;
    ext_info[hard_num].last_sector = 0;
    ext_info[hard_num].offset = 0;
    ext_info[hard_num].flags = 0;
    ext_info[hard_num].id = FREE_SPACE;
    ext_info[hard_num].num = PRIMARY;
}

int add_part(int num, int id, int flags, int first, int last, int offset,
	     int want_label)
{
    int i, pri = 0, log = 0;

    if (num_parts[hard_num] == MAXIMUM_PARTS ||
	first < 0 ||
	first >= cylinders[hard_num]*heads[hard_num]*sectors[hard_num] ||
	last < 0 ||
	last >= cylinders[hard_num]*heads[hard_num]*sectors[hard_num]) {
	return -1;		
    }

    for (i = 0; i < num_parts[hard_num]; i++)
	if (p_info[hard_num][i].id > 0 && IS_PRIMARY(p_info[hard_num][i].num))
	    pri++;
	else if (p_info[hard_num][i].id > 0 && IS_LOGICAL(p_info[hard_num][i].num))
	    log++;
    if (IS_EXTENDED(ext_info[hard_num].id) && log > 0)
	pri++;

    if (IS_PRIMARY(num))
	if (pri >= 4) {
	    return -1;		
	} else
	    pri++;

    for (i = 0; i < num_parts[hard_num] && p_info[hard_num][i].last_sector < first; i++);

    if (i == num_parts[hard_num] || p_info[hard_num][i].id != FREE_SPACE
	|| last > p_info[hard_num][i].last_sector) {
	return -1;
    }

    if (IS_EXTENDED(id)) {
	if (ext_info[hard_num].id != FREE_SPACE) {
	    return -1;		
	}
	else if (IS_PRIMARY(num)) {
	    ext_info[hard_num].first_sector = first;
	    ext_info[hard_num].last_sector = last;
	    ext_info[hard_num].offset = offset;
	    ext_info[hard_num].flags = flags;
	    ext_info[hard_num].id = id;
	    ext_info[hard_num].num = num;
	    ext_info[hard_num].dos_label[0] = 0;
	    return 0;
	} else {
	    return -1;		
	}
    }

    if (IS_LOGICAL(num)) {
	if (!IS_EXTENDED(ext_info[hard_num].id)) {
	    printf("!!!! Internal error creating logical "
			  "drive with no extended partition !!!!");
	} else {
	    if (first < ext_info[hard_num].first_sector) {
		if (i < num_parts[hard_num]-1 && IS_PRIMARY(p_info[hard_num][i+1].num)) {
		    return -1;
		} else {
		    if (first == 0) {
			ext_info[hard_num].first_sector = 0;
			ext_info[hard_num].offset = first = offset;
		    } else {
			ext_info[hard_num].first_sector = first;
		    }
		}
	    } else if (last > ext_info[hard_num].last_sector) {
		if (i > 0 && IS_PRIMARY(p_info[hard_num][i-1].num)) {
		    return -1;
		} else {
		    ext_info[hard_num].last_sector = last;
		}
	    }
	}
    }

    if (first != p_info[hard_num][i].first_sector &&
	!(IS_LOGICAL(num) && first == offset)) {
	insert_empty_part(i, p_info[hard_num][i].first_sector, first-1);
	i++;
    }

    if (last != p_info[hard_num][i].last_sector)
	insert_empty_part(i+1, last+1, p_info[hard_num][i].last_sector);

    p_info[hard_num][i].first_sector = first;
    p_info[hard_num][i].last_sector = last;
    p_info[hard_num][i].offset = offset;
    p_info[hard_num][i].flags = flags;
    p_info[hard_num][i].id = id;
    p_info[hard_num][i].num = num;
    p_info[hard_num][i].dos_label[0] = 0;
    if (want_label && IS_DOS_PART(id))
	 get_dos_label(i);

    check_part_info();

    return 0;
}



void fill_part_table(struct partition *p, partition_info *pi)
{
    int sects;

    p->boot_ind = pi->flags;
    p->sys_ind = pi->id;
    if (IS_LOGICAL(pi->num))
	p->start_sect = pi->offset;
    else
	p->start_sect = pi->first_sector + pi->offset;
    p->nr_sects = pi->last_sector - (pi->first_sector+pi->offset) + 1;
    sects = (((pi->first_sector+pi->offset)/(sectors[hard_num]*heads[hard_num]) > 1023) ?
	     heads[hard_num]*sectors[hard_num]*1024 - 1 : pi->first_sector+pi->offset);
    set_hsc(p->head, p->sector, p->cyl, sects);
    sects = ((pi->last_sector/(sectors[hard_num]*heads[hard_num]) > 1023) ?
	     heads[hard_num]*sectors[hard_num]*1024 - 1 : pi->last_sector);
    set_hsc(p->end_head, p->end_sector, p->end_cyl, sects);
}

void fill_primary_table(partition_table *buffer)
{
    int i;

    for (i = 0x1BE; i < SECTOR_SIZE; i++)
	buffer->c.b[i] = 0;

    for (i = 0; i < num_parts[hard_num]; i++)
	if (IS_PRIMARY(p_info[hard_num][i].num))
	    fill_part_table(&(buffer->p.part[p_info[hard_num][i].num]), &(p_info[hard_num][i]));

    if (IS_EXTENDED(ext_info[hard_num].id))
	fill_part_table(&(buffer->p.part[ext_info[hard_num].num]), &ext_info[hard_num]);

    buffer->p.flag = PART_TABLE_FLAG;
}

void fill_logical_table(partition_table *buffer, partition_info *pi)
{
    struct partition *p;
    int i, sects;

    for (i = 0; i < logical && pi->first_sector != logical_sectors[i]; i++);
    if (i == logical || buffer->p.flag != (unsigned short)PART_TABLE_FLAG)
	for (i = 0; i < SECTOR_SIZE; i++)
	    buffer->c.b[i] = 0;

    // Zero out existing table 
    for (i = 0x1BE; i < SECTOR_SIZE; i++)
	buffer->c.b[i] = 0;

    fill_part_table(&(buffer->p.part[0]), pi);

    for (i = 0;
	 i < num_parts[hard_num] && pi->num != p_info[hard_num][i].num - 1;
	 i++);

    if (i < num_parts[hard_num]) {
	p = &(buffer->p.part[1]);
	pi = &(p_info[hard_num][i]);

	p->boot_ind = 0;
	p->sys_ind = DOS_EXTEND;
	p->start_sect = pi->first_sector - ext_info[hard_num].first_sector;
	p->nr_sects = pi->last_sector - pi->first_sector + 1;
	sects = ((pi->first_sector/(sectors[hard_num]*heads[hard_num]) > 1023) ?
		 heads[hard_num]*sectors[hard_num]*1024 - 1 : pi->first_sector);
	set_hsc(p->head, p->sector, p->cyl, sects);
	sects = ((pi->last_sector/(sectors[hard_num]*heads[hard_num]) > 1023) ?
		 heads[hard_num]*sectors[hard_num]*1024 - 1 : pi->last_sector);
	set_hsc(p->end_head, p->end_sector, p->end_cyl, sects);
    }

    buffer->p.flag = PART_TABLE_FLAG;
}


PyObject* true_clear_partinfo(PyObject* self, PyObject* args)
{
    int hardnum;	
    PyObject *clear_list;
    clear_list = PyList_New(0);
    if(!PyArg_ParseTuple(args, "i", &hardnum))
	return NULL;
    hard_num = hardnum;
    num_parts[hard_num] = 1;
    p_info[hard_num][0].first_sector = 0;
    p_info[hard_num][0].last_sector = sectors[hard_num]*heads[hard_num]*cylinders[hard_num] - 1;
    p_info[hard_num][0].offset = 0;
    p_info[hard_num][0].flags = 0;
    p_info[hard_num][0].id = FREE_SPACE;
    p_info[hard_num][0].num = PRI_LOG;

    ext_info[hard_num].first_sector = 0;
    ext_info[hard_num].last_sector = 0;
    ext_info[hard_num].offset = 0;
    ext_info[hard_num].flags = 0;
    ext_info[hard_num].id = FREE_SPACE;
    ext_info[hard_num].num = PRIMARY;
    PyList_Append(clear_list, Py_BuildValue("i",hardnum));
    return clear_list;
}


PyObject* true_partinfo(PyObject* self, PyObject* args)
{
    
    int i,p ,num_sect, hardnum, clear_ll = 0;
    int size;
    int sizes[10];
    char *dev;
    struct hd_geometry geometr[10];
    partition_info tmp_ext = { 0, 0, 0, 0, FREE_SPACE, PRIMARY };
    PyObject *list;
    list = PyList_New(0);
    if(!PyArg_ParseTuple(args, "isi", &hardnum, &dev, &clear_ll ))
	return NULL;
    hard_num = hardnum;
    if ((fd[hard_num] = open(dev, O_RDWR)) < 0) {
	 if ((fd[hard_num] = open(dev, O_RDONLY)) < 0)
	 opentype = O_RDONLY;
    } else
	 opentype = O_RDWR;
    read_sector(bufferss[hard_num].c.b, 0 );
    if (!ioctl(fd[hard_num], HDIO_GETGEO, &geometr[hard_num])) {
	    heads[hard_num] = geometr[hard_num].heads;
	    sectors[hard_num] = geometr[hard_num].sectors;
	if (!cylinders[hard_num]){
	    cylinders[hard_num] = geometr[hard_num].cylinders;
            num_sect = num_cyls(cylinders[hard_num]*1024*1024)*sectors[hard_num]*heads[hard_num];
		}
  }

    if (!heads || !sectors || !cylinders){
    	 read_error = 1;}
    clear_p_info(hardnum);
    if (clear_ll == 0){
    if (!zero_table) {
	for (i = 0; i < 4; i++) {
	    int bs = bufferss[hard_num].p.part[i].start_sect;

	    if (bufferss[hard_num].p.part[i].sys_ind > 0 &&
		add_part(i,
			 bufferss[hard_num].p.part[i].sys_ind,
			 bufferss[hard_num].p.part[i].boot_ind,
			 ((bs <= sectors[hard_num]) ? 0 : bs),
			 bufferss[hard_num].p.part[i].start_sect +
			 bufferss[hard_num].p.part[i].nr_sects - 1,
			 ((bs <= sectors[hard_num]) ? bs : 0),
			 1)) {
		read_error = 1;
	    }
	    if (IS_EXTENDED(bufferss[hard_num].p.part[i].sys_ind)){
		tmp_ext = ext_info[hard_num];}
	}

	if (IS_EXTENDED(tmp_ext.id)) {
	    ext_info[hard_num] = tmp_ext;
	    logical_sectors[logical] =
		 ext_info[hard_num].first_sector + ext_info[hard_num].offset;
	    read_sector(bufferss[hard_num].c.b, logical_sectors[logical++]);
	    i = 4;
	    do {
		for (p = 0;
		     p < 4 && (!bufferss[hard_num].p.part[p].sys_ind ||
			      IS_EXTENDED(bufferss[hard_num].p.part[p].sys_ind));
		     p++);

		if (p < 4 && add_part(i++,
			     bufferss[hard_num].p.part[p].sys_ind,
			     bufferss[hard_num].p.part[p].boot_ind,
			     logical_sectors[logical-1],
			     logical_sectors[logical-1] +
			     bufferss[hard_num].p.part[p].start_sect +
			     bufferss[hard_num].p.part[p].nr_sects - 1,
			     bufferss[hard_num].p.part[p].start_sect,
			     1)) {
			read_error = 1;
		}

		for (p = 0;
		     p < 4 && !IS_EXTENDED(bufferss[hard_num].p.part[p].sys_ind);
		     p++);
		if (p < 4) {
		    logical_sectors[logical] = ext_info[hard_num].first_sector
			 + ext_info[hard_num].offset + bufferss[hard_num].p.part[p].start_sect;
		    read_sector(bufferss[hard_num].c.b, logical_sectors[logical++]);
		}
	    } while (p < 4 && logical < MAXIMUM_PARTS-4);
	}
    }
    }
    if (read_error == 0){
	for(p = 0; num_parts[hard_num] > p ; p++){
       		size = p_info[hard_num][p].last_sector - p_info[hard_num][p].first_sector + 1;
       		sizes[p] = ceil(size/20.48)/100;
		PyList_Append(list, Py_BuildValue("siiiii",dev,p_info[hard_num][p].num,sizes[p],
				p_info[hard_num][p].id,p_info[hard_num][p].flags,num_parts[hard_num]));
	}
    }
    else{		
	PyList_Append(list, Py_BuildValue("siiiii","error",hard_num,0,0,0,0));}
    return list;	
}


PyObject* true_partsize(PyObject* self, PyObject* args)
{
	int p, hardnum,size,sizes[10];
	PyObject* one_more;
	one_more = PyList_New(0);
        if(!PyArg_ParseTuple(args,"i",&hardnum))
		return NULL;
	for(p = 0; num_parts[hard_num] > p ; p++){
       		size = p_info[hard_num][p].last_sector - p_info[hard_num][p].first_sector + 1;
       		sizes[p] = ceil(size/20.48)/100;
		PyList_Append(one_more, Py_BuildValue("iiiiiii",p_info[hard_num][p].num,p_info[hard_num][p].first_sector,
				p_info[hard_num][p].last_sector, sizes[p],
				p_info[hard_num][p].id,p_info[hard_num][p].flags,num_parts[hard_num]));
	}
		size = ext_info[hard_num].last_sector - ext_info[hard_num].first_sector + 1;
		PyList_Append(one_more, Py_BuildValue("iii",ext_info[hard_num].num,ext_info[hard_num].first_sector,ext_info[hard_num].last_sector));
	return one_more;
	
}

PyObject* true_partsizeorg(PyObject* self, PyObject *args)
{
   int close_hd;
   PyObject* close_list;
   close_list = PyList_New(0);
   if(!PyArg_ParseTuple(args,"i",&close_hd))
	return NULL;
   close(fd[close_hd]);
   PyList_Append(close_list, Py_BuildValue("i",close_hd));
   return close_list;
}


PyObject* true_bootable(PyObject* self, PyObject *args)
{
   int hardnum,i,number,p;
   PyObject* boot_list;
   boot_list = PyList_New(0);
   if(!PyArg_ParseTuple(args,"ii",&hardnum, &number))
	return NULL;
   hard_num = hardnum;
   for(p = 0; num_parts[hard_num] > p ; p++){
	if( p_info[hard_num][p].num == number){
		i = p;
		break;
		}
	}
   p_info[hard_num][i].flags = 0x80;
   PyList_Append(boot_list, Py_BuildValue("i",i));
   return boot_list;
}



void remove_part(int i)
{
  int p;
  for(p = i; p < num_parts[hard_num]; p++)
	p_info[hard_num][p] = p_info[hard_num][p + 1];
  num_parts[hard_num]--;
}




PyObject* true_delpartition(PyObject* self, PyObject* args)
{
    int i, hardnum, number,p, j;
    int num;
    PyObject* del_list;
    del_list = PyList_New(0);
    if(!PyArg_ParseTuple(args,"ii",&hardnum, &number))
	return NULL;
    hard_num = hardnum;

    for(p = 0; num_parts[hard_num] > p ; p++){
	if( p_info[hard_num][p].num == number){
		i = p;
		break;
		}
	}
    num = p_info[hard_num][i].num;
    if (i > 0 && (p_info[hard_num][i-1].id == FREE_SPACE ||
		  p_info[hard_num][i-1].id == UNUSABLE)) {
	p_info[hard_num][i-1].last_sector = p_info[hard_num][i].last_sector;
	remove_part(i--);
    }

    if (i < num_parts[hard_num] - 1 && (p_info[hard_num][i+1].id == FREE_SPACE ||
			      p_info[hard_num][i+1].id == UNUSABLE)) {
	p_info[hard_num][i+1].first_sector = p_info[hard_num][i].first_sector;
	remove_part(i);
    }

    if (i > 0)
	p_info[hard_num][i].first_sector = p_info[hard_num][i-1].last_sector + 1;
    else
	p_info[hard_num][i].first_sector = 0;

    if (i < num_parts[hard_num] - 1)
	p_info[hard_num][i].last_sector = p_info[hard_num][i+1].first_sector - 1;
    else
	p_info[hard_num][i].last_sector = sectors[hard_num]*heads[hard_num]*cylinders[hard_num] - 1;

    p_info[hard_num][i].offset = 0;
    p_info[hard_num][i].flags = 0;
    p_info[hard_num][i].id = FREE_SPACE;
    p_info[hard_num][i].num = PRI_OR_LOG;

    if (IS_LOGICAL(num)) {
	if (i == 0 || (i > 0 && IS_PRIMARY(p_info[hard_num][i-1].num)))
	    ext_info[hard_num].first_sector = p_info[hard_num][i].last_sector + 1;
	if (i == num_parts[hard_num]-1 ||
	    (i < num_parts[hard_num]-1 && IS_PRIMARY(p_info[hard_num][i+1].num)))
	    ext_info[hard_num].last_sector = p_info[hard_num][i].first_sector - 1;
	for (i = 0; i < num_parts[hard_num]; i++)
	    if (p_info[hard_num][i].num > num)
		p_info[hard_num][i].num--;
    }

    check_part_info();
    PyList_Append(del_list, Py_BuildValue("i",i));
    return del_list;
}



PyObject* true_writepartition(PyObject* self, PyObject* args)
{
    int i, done = 0, len ;
    int hardnum;
    partition_table buffer;
    char response[80];
    PyObject* list;
    if (!PyArg_ParseTuple(args, "i" ,&hardnum))
	return NULL; 
    hard_num = hardnum;
    if (opentype == O_RDONLY) 
	 return;
    
    read_sector(buffer.c.b, 0);
    fill_primary_table(&buffer);
    write_sector(buffer.c.b, 0);
    for (i = 0; i < num_parts[hard_num]; i++)
	if (IS_LOGICAL(p_info[hard_num][i].num)) {
	    read_sector(buffer.c.b, p_info[hard_num][i].first_sector);
	    fill_logical_table(&buffer, &(p_info[hard_num][i]));
	    write_sector(buffer.c.b, p_info[hard_num][i].first_sector);

	}
    sync();
    sleep(1);
    if (!ioctl(fd[hard_num],BLKRRPART))
	printf("chagned success\n");
    sync();
    sleep(1);

    list = PyList_New(0);
    PyList_Append(list, Py_BuildValue( "i",hardnum ));
    return list;
}

PyObject* true_changid(PyObject* self, PyObject* args)
{	
    int i,hardnum, new_id, p ;
    PyObject* chang_id;
    if (!PyArg_ParseTuple(args, "iii" ,&hardnum, &i, &new_id))
	return NULL; 
    hard_num = hardnum;
    for(p = 0; num_parts[hard_num] > p; p++){
	    if(p_info[hard_num][p].num == i){
		    p_info[hard_num][p].id = new_id;
		    break;}
    }
    chang_id = PyList_New(0);
    PyList_Append(chang_id, Py_BuildValue( "i",hardnum ));
    return chang_id;
}



PyObject* true_newpart_size(PyObject* self, PyObject* args)
{
    int i, j,num ,hardnum, size;
    int sizes = 0;
    PyObject* list_size;
    list_size = PyList_New(0);
    if (!PyArg_ParseTuple(args, "i" ,&hardnum ))
	return NULL; 
    hard_num = hardnum;
    for(j = 0; j < num_parts[hard_num]; j++){
	if(p_info[hard_num][j].id == 0x00){
		size = p_info[hard_num][j].last_sector - p_info[hard_num][j].first_sector + 1;
		sizes = ceil(size/20.48)/100;}
    }	
    	PyList_Append(list_size, Py_BuildValue( "i",sizes));
    return list_size;
}    


PyObject* true_newpart_info(PyObject* self, PyObject* args)
{	
    int i, j,nums ,hardnum;
    PyObject* list_com;
    list_com = PyList_New(0);

    if (!PyArg_ParseTuple(args, "i" ,&hardnum ))
	return NULL; 
    hard_num = hardnum;
    for(j = 0; j < num_parts[hard_num]; j++){
	nums = p_info[hard_num][j].num; 
	if(nums >= 0)
    	   PyList_Append(list_com, Py_BuildValue( "i",nums + 1));
    }
    return list_com;
}    






PyObject* true_newpartition(PyObject* self, PyObject* args)
{
    int i = -1, intsize, pri_log, new_id, hardnum,fill;
    int offset = 0;
    int flags = 0;
    int id = LINUX;
    int num = -1;
    int len, ext, j;
    int a = 1,b = 2,cd = 3;
    int first, last, num_sect;
    char *size;
    PyObject* new_list;
    if (!PyArg_ParseTuple(args, "isii" ,&hardnum ,&size ,&new_id ,&fill))
	return NULL; 
    hard_num = hardnum;
    intsize = atoi(size);
    num_sect = num_cyls(intsize*1024*1024)*sectors[hard_num]*(heads[hard_num]);
    for(j = 0; j < num_parts[hard_num]; j++){
	if(p_info[hard_num][j].id == 0x00)
		i = j;
	}
    if (i == 0)
	    pri_log = 1;
    else
	    pri_log = 2;
    first = p_info[hard_num][i].first_sector;
    if (p_info[hard_num][i].num == PRI_OR_LOG) {
	if (pri_log == 1)
	    num = find_primary(hard_num);
	else if (pri_log == 2)
	    num = find_logical(hard_num,i);
	else
	    return NULL;
    } else if (p_info[hard_num][i].num == PRIMARY)
	num = find_primary(hard_num);
    else if (p_info[hard_num][i].num == LOGICAL)
	num = find_logical(hard_num,i);
    else
    	num = -1;
    if(num != -1){
	if(fill == 0){
    		if (num_sect < p_info[hard_num][i].last_sector - p_info[hard_num][i].first_sector + 1) {
	    		last = first + num_sect - 1;
    		}
		else
			last = p_info[hard_num][i].last_sector;
	}else
		last = p_info[hard_num][i].last_sector;
    	if (IS_LOGICAL(num) && !IS_EXTENDED(ext_info[hard_num].id)) {
		if ((ext = find_primary(hard_num)) < 0) {
	    		return NULL;
		}
		(void) add_part(ext, DOS_EXTEND, 0, first, last,
		       	(first == 0 ? sectors[hard_num] : 0), 0);
		first = ext_info[hard_num].first_sector + ext_info[hard_num].offset;
    	}

    	if (IS_LOGICAL(num)){
		inc_logical(i);
		}
    	if (first == 0 || IS_LOGICAL(num))
		offset = sectors[hard_num];
	
    	(void) add_part(num, id, flags, first, last, offset, 0);
        p_info[hard_num][i].id = new_id;
    }
    new_list = PyList_New(0);
    PyList_Append(new_list, Py_BuildValue( "i",num));
    return new_list;
}



PyObject* true_editpartition(PyObject* self, PyObject* args)
{
    int i, j, p, number,intsize, new_id, num_sect,hardnum, fill;
    int lastsize[10] ;
    int tmps_size = -1, insert_empty = 0;
    int tmps_i = 0, tmps_num, stop_id;
    char *size;
    PyObject* edit_list;
    edit_list = PyList_New(0);
    if(!PyArg_ParseTuple(args,"iisiii", &hardnum, &number, &size, &new_id, &tmps_num, &fill))
	return NULL;
    hard_num = hardnum;
    if (tmps_num == -1)
	    stop_id = num_parts[hard_num] - 1;
    else{
    	for(p = 0; num_parts[hard_num] > p ; p++){
		if( p_info[hard_num][p].num == tmps_num){
			stop_id = p;
			break;
			}
		}
    }
    for(p = 0; num_parts[hard_num] > p ; p++){
	if( p_info[hard_num][p].num == number){
		i = p;
		break;
		}
	}
    for (j = 0 ; j < num_parts[hard_num]; j++){
	lastsize[j] = p_info[hard_num][j].last_sector - p_info[hard_num][j].first_sector + 1;
	insert_empty = p_info[hard_num][j].last_sector;
	if(p_info[hard_num][j].id == 0x00){ 
		tmps_size = p_info[hard_num][j].last_sector;
		tmps_i = j;
	}
    }
    intsize = atoi(size);
    num_sect = num_cyls(intsize*1024*1024)*sectors[hard_num]*heads[hard_num];
    p_info[hard_num][i].id = new_id;
    if(fill == 0){
    	p_info[hard_num][i].last_sector = p_info[hard_num][i].first_sector + num_sect - 1;
    	for (j = i  ; j < stop_id ; j++){
	    if(p_info[hard_num][j + 1].num >= 0){
		if( j + 1 != stop_id){    
			p_info[hard_num][j + 1].first_sector = p_info[hard_num][j].last_sector + 1;
			p_info[hard_num][j + 1].last_sector = p_info[hard_num][j + 1].first_sector + lastsize[j + 1] - 1;}
		else{
			insert_empty_part(j+1,p_info[hard_num][j+1].first_sector, p_info[hard_num][j+1].last_sector);}
	    }else{
		p_info[hard_num][j + 1].first_sector = p_info[hard_num][j].last_sector + 1;}
    	} 
    }else{
    	p_info[hard_num][i].last_sector = p_info[hard_num][i].first_sector + num_sect - 1;
    	for (j = i  ; j < tmps_i; j++){
	    if(p_info[hard_num][j + 1].num >= 0){
		p_info[hard_num][j + 1].first_sector = p_info[hard_num][j].last_sector + 1;
		p_info[hard_num][j + 1].last_sector = p_info[hard_num][j + 1].first_sector + lastsize[j + 1] - 1;
	    }else
		p_info[hard_num][j + 1].first_sector = tmps_size;
    	} 

    }		
    for (j = 0 ; j < num_parts[hard_num] - 1 ; j ++){
    	if(p_info[hard_num][j].num < 4 && p_info[hard_num][j + 1].num > 3){
		ext_info[hard_num].first_sector = p_info[hard_num][j].last_sector + 1;
		break;
		}
	}
    for (j = 0 ; j < num_parts[hard_num] - 1; j++){
	if(p_info[hard_num][j].num > 3 && p_info[hard_num][j + 1].num < 0){
		ext_info[hard_num].last_sector = p_info[hard_num][j].last_sector;
		break;
		}
    	}
    if (p_info[hard_num][num_parts[hard_num] - 1].num > 3){
    	if (p_info[hard_num][num_parts[hard_num] - 1].last_sector != ext_info[hard_num].last_sector)
		ext_info[hard_num].last_sector = p_info[hard_num][num_parts[hard_num] - 1].last_sector;}
    if (tmps_size == -1){
    	if (p_info[hard_num][num_parts[hard_num] - 1].last_sector != insert_empty){
	    insert_empty_part(num_parts[hard_num],p_info[hard_num][num_parts[hard_num] - 1].last_sector + 1,insert_empty);
	}
    }
    if(fill == 1)
	    remove_part(tmps_i);
    PyList_Append(edit_list, Py_BuildValue("ii", i, intsize));
    return edit_list;
}

